//---------------------------------------------------------------------------

#ifndef MainFormH
#define MainFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "QBIBWindow.hpp"
#include "QBWindow.hpp"
#include <ComCtrls.hpp>
#include <Db.hpp>
#include <DBCtrls.hpp>
#include <DBGrids.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <Grids.hpp>
#include <IBCustomDataSet.hpp>
#include <IBDatabase.hpp>
#include <IBQuery.hpp>
#include <ImgList.hpp>
#include <Menus.hpp>
#include <ToolWin.hpp>
#include <DB.hpp>
//---------------------------------------------------------------------------
class TfmMain : public TForm
{
__published:	// IDE-managed Components
    TStatusBar *StatusBar1;
    TPanel *paTables;
    TPanel *paPages;
    TPageControl *Pages;
    TTabSheet *tsBuilder;
    TTabSheet *tsSQL;
    TTabSheet *tsResult;
    TListView *lvTables;
    TInterBaseQueryBuilder *QueryBuilder;
    TMemo *mmSQL;
    TDBGrid *DBGrid;
    TDBNavigator *DBNavigator;
    TImageList *ilList;
    TDataSource *DataSource;
    TCoolBar *CoolBar;
    TToolBar *ToolBar;
    TToolButton *tbLoad;
    TToolButton *tbSave;
    TToolButton *ToolButton3;
    TToolButton *tbExecute;
    TToolButton *ToolButton5;
    TToolButton *tbClear;
    TMainMenu *MainMenu;
    TMenuItem *miFile;
    TMenuItem *miHelp;
    TMenuItem *miAbout;
    TMenuItem *miLoad;
    TMenuItem *miSave;
    TMenuItem *miSaveAs;
    TMenuItem *miSeparator1;
    TMenuItem *miExit;
    TMenuItem *miQuery;
    TMenuItem *miExecute;
    TMenuItem *miSeparator2;
    TMenuItem *miClear;
    TSplitter *Splitter;
    TImageList *ilMenu;
    TSaveDialog *dlgSave;
    TOpenDialog *dlgOpen;
    TToolButton *tbConnect;
    TToolButton *tbDisconnect;
    TToolButton *ToolButton4;
    TMenuItem *miSeparator3;
    TMenuItem *miConnect;
    TMenuItem *miDisconnect;
    TIBQuery *Query;
    TIBDatabase *Database;
    TIBTransaction *Transaction;
    TMenuItem *miView;
    TMenuItem *miShowSystemTables;
    TMenuItem *miSeparator4;
    TMenuItem *miQBOptions;
    void __fastcall lvTablesDblClick(TObject *Sender);
    void __fastcall QueryBuilderDragOver(TObject *Sender, TObject *Source,
      int X, int Y, TDragState State, bool &Accept);
    void __fastcall QueryBuilderDragDrop(TObject *Sender, TObject *Source,
      int X, int Y);
    void __fastcall QueryBuilderGetTableFields(const AnsiString NameOfTable,
      TDataSet *&ADataSet, TParams *&AParams);
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall PagesChanging(TObject *Sender, bool &AllowChange);
    void __fastcall tbExecuteClick(TObject *Sender);
    void __fastcall tbClearClick(TObject *Sender);
    void __fastcall tbLoadClick(TObject *Sender);
    void __fastcall tbSaveClick(TObject *Sender);
    void __fastcall miExitClick(TObject *Sender);
    void __fastcall tbConnectClick(TObject *Sender);
    void __fastcall tbDisconnectClick(TObject *Sender);
    void __fastcall DatabaseAfterConnect(TObject *Sender);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall DatabaseAfterDisconnect(TObject *Sender);
    void __fastcall miShowSystemTablesClick(TObject *Sender);
    void __fastcall miAboutClick(TObject *Sender);
    void __fastcall miQBOptionsClick(TObject * Sender);
    void __fastcall QueryBuilderParserError(TObject *Sender,
      const AnsiString ErrorMsg, const AnsiString Token,
      int LineNo, int LinePos);
private:	// User declarations
    void __fastcall UpdateCaption();
    void __fastcall RefreshTableList(bool ShowSystem);
    AnsiString __fastcall FormatByDialect(const AnsiString Ident, short Dialect);
public:		// User declarations
        __fastcall TfmMain(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TfmMain *fmMain;
//---------------------------------------------------------------------------
#endif
 